/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of OpenSSL.xs. Do not edit this file, edit OpenSSL.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "OpenSSL.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

/* #include <openssl/ossl_typ.h> */
#include <openssl/x509.h>
#include <openssl/x509v3.h>
#include <openssl/bn.h>
#include <openssl/rsa.h>
#include <openssl/dsa.h>

/* #include "const-c.inc" */
/* INCLUDE: const-xs.inc */

/* Standard trick to have a C pointer as a Perl object, see the typemap */
typedef X509          * OpenCA_OpenSSL_X509;
typedef X509_CRL      * OpenCA_OpenSSL_CRL;
typedef NETSCAPE_SPKI * OpenCA_OpenSSL_SPKAC;
typedef X509_REQ      * OpenCA_OpenSSL_PKCS10;

/* general pointer to avoid memory leaks because fo char * returns */
char * char_ptr = NULL;
char * uchar_ptr = NULL;

/* free is only safe if we test the pointer before free and
   reset the pointer to NULL after this macro */
#define SAFEFREE(pointer) if (pointer!=NULL) Safefree(pointer); pointer=NULL;

/* hack to avoid MSB escaping by OpenSSL */
#define OPENCA_FLAG_RFC2253 (XN_FLAG_RFC2253&(~ASN1_STRFLGS_ESC_MSB))

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 48 "OpenSSL.c"

XS(XS_OpenCA__OpenSSL__X509__new_from_der); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509__new_from_der)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::_new_from_der", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv = ST(0);
#line 44 "OpenSSL.xs"
	const unsigned char * dercert;
	STRLEN certlen;
#line 66 "OpenSSL.c"
	OpenCA_OpenSSL_X509	RETVAL;
#line 47 "OpenSSL.xs"
	dercert = (const unsigned char *) SvPV(sv, certlen);
	RETVAL = d2i_X509(NULL,&dercert,certlen);
#line 71 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::X509",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509__new_from_pem); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509__new_from_pem)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::_new_from_pem", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv = ST(0);
#line 56 "OpenSSL.xs"
	unsigned char * pemcert;
	const unsigned char * dercert;
	STRLEN certlen, inlen;
	char inbuf[512];
	BIO *bio_in, *bio_out, *b64;
#line 99 "OpenSSL.c"
	OpenCA_OpenSSL_X509	RETVAL;
#line 62 "OpenSSL.xs"
	pemcert = (unsigned char *) SvPV_force(sv, certlen);
	bio_in  = BIO_new(BIO_s_mem());
	bio_out = BIO_new(BIO_s_mem());
	b64     = BIO_new(BIO_f_base64());

	/* load encoded data into bio_in */
	BIO_write(bio_in, pemcert+27, certlen-27-25);

	/* set EOF for memory bio */
	BIO_set_mem_eof_return(bio_in, 0);

	/* decode data from one bio into another one */
	BIO_push(b64, bio_in);
        while((inlen = BIO_read(b64, inbuf, 512)) > 0)
		BIO_write(bio_out, inbuf, inlen);

	/* create dercert */
	certlen = BIO_get_mem_data(bio_out, &dercert);

	/* create cert */
	RETVAL = d2i_X509(NULL,&dercert,certlen);
	BIO_free(bio_in);
	BIO_free(bio_out);
        BIO_free(b64);
#line 126 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::X509",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_free); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_free)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::free", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 93 "OpenSSL.xs"
	if (cert != NULL) X509_free(cert);
        SAFEFREE(char_ptr);
        SAFEFREE(uchar_ptr);
#line 159 "OpenSSL.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenCA__OpenSSL__X509_serial); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_serial)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::serial", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 101 "OpenSSL.xs"
	SAFEFREE(char_ptr);
	char_ptr = i2s_ASN1_INTEGER(NULL,X509_get_serialNumber(cert));
        RETVAL = char_ptr;
#line 191 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_subject); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_subject)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::subject", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 111 "OpenSSL.xs"
	BIO *out;
	char *subject;
	int n;
#line 215 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 115 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, X509_get_subject_name(cert), 0, OPENCA_FLAG_RFC2253);
	n = BIO_get_mem_data(out, &subject);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, subject, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 234 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_openssl_subject); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_openssl_subject)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::openssl_subject", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 130 "OpenSSL.xs"
	BIO *out;
	char *subject;
	int n;
#line 258 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 134 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, X509_get_subject_name(cert), 0, 0);
	n = BIO_get_mem_data(out, &subject);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, subject, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 277 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_issuer); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_issuer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::issuer", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 149 "OpenSSL.xs"
	BIO *out;
	char *issuer;
	int n;
#line 301 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 153 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, X509_get_issuer_name(cert), 0, OPENCA_FLAG_RFC2253);
	n = BIO_get_mem_data(out, &issuer);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, issuer, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 320 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_notBefore); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_notBefore)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::notBefore", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 168 "OpenSSL.xs"
	char *not;
	int n;
	BIO *out;
#line 344 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 172 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ASN1_TIME_print(out, X509_get_notBefore(cert));
	n = BIO_get_mem_data(out, &not);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, not, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 363 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_notAfter); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_notAfter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::notAfter", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 187 "OpenSSL.xs"
	char *not;
	int n;
	BIO *out;
#line 387 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 191 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ASN1_TIME_print(out, X509_get_notAfter(cert));
	n = BIO_get_mem_data(out, &not);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, not, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 406 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_alias); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_alias)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::alias", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 206 "OpenSSL.xs"
	int n;
	unsigned char * alias;
#line 429 "OpenSSL.c"
	unsigned char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 209 "OpenSSL.xs"
	alias = X509_alias_get0(cert, &n);
        if (alias != NULL)
        {
	    SAFEFREE(uchar_ptr);
	    Newz(0, uchar_ptr, n+1, char);
	    memcpy (uchar_ptr, alias, n);
	    RETVAL = uchar_ptr;
        } else {
            RETVAL = NULL;
        }
#line 450 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_fingerprint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::fingerprint", "cert, digest_name=\"sha1\"");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
	char *	digest_name;
#line 227 "OpenSSL.xs"
	BIO *out;
	int j;
	unsigned int n;
	const EVP_MD *digest;
	char * fingerprint;
	unsigned char md[EVP_MAX_MD_SIZE];
	unsigned char str[3];
#line 479 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");

	if (items < 2)
	    digest_name = "sha1";
	else {
	    digest_name = (char *)SvPV_nolen(ST(1));
	}
#line 235 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	if (!strcmp ("sha1", digest_name))
		digest = EVP_sha1();
	else
		digest = EVP_md5();
	if (X509_digest(cert,digest,md,&n))
	{
		BIO_printf(out, "%s:", OBJ_nid2sn(EVP_MD_type(digest)));
		for (j=0; j<(int)n; j++)
		{
			BIO_printf (out, "%02X",md[j]);
			if (j+1 != (int)n) BIO_printf(out,":");
		}
	}
	n = BIO_get_mem_data(out, &fingerprint);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, fingerprint, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 516 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_subject_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_subject_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::subject_hash", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 262 "OpenSSL.xs"
#line 537 "OpenSSL.c"
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 263 "OpenSSL.xs"
        /* FIXME: potential memory hole */
        /* is this code clean -  memory hole ??? */
	RETVAL = X509_subject_name_hash(cert);
#line 551 "OpenSSL.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_emailaddress); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_emailaddress)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::emailaddress", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 273 "OpenSSL.xs"
	int j, n;
        STACK *emlst;
	BIO *out;
	unsigned char *emails;
#line 576 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 278 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	emlst = X509_get1_email(cert);
	for (j = 0; j < sk_num(emlst); j++)
	{
		BIO_printf(out, "%s", sk_value(emlst, j));
		if (j+1 != (int)sk_num(emlst))
			BIO_printf(out,"\n");
	}
	X509_email_free(emlst);
	n = BIO_get_mem_data(out, &emails);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, emails, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 602 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::version", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 300 "OpenSSL.xs"
	BIO *out;
	char *version;
	unsigned char buf[1024];
	long l;
#line 627 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 305 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	l = X509_get_version(cert);
	BIO_printf (out,"%lu (0x%lx)",l+1,l);
	l = BIO_get_mem_data(out, &version);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, l+1, char);
	memcpy (char_ptr, version, l);
	RETVAL = char_ptr;
	BIO_free(out);
#line 647 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_pubkey_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_pubkey_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::pubkey_algorithm", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 321 "OpenSSL.xs"
	BIO *out;
	char *pubkey;
	X509_CINF *ci;
	int n;
#line 672 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 326 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ci = cert->cert_info;
	i2a_ASN1_OBJECT(out, ci->key->algor->algorithm);
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
	memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 692 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::pubkey", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 342 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	char *pubkey;
	int n;
#line 717 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 347 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_get_pubkey(cert);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			RSA_print(out,pkey->pkey.rsa,0);
		else if (pkey->type == EVP_PKEY_DSA)
			DSA_print(out,pkey->pkey.dsa,0);
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
	memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 744 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_keysize); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_keysize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::keysize", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 370 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	char * pubkey;
	int n;
#line 769 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 375 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_get_pubkey(cert);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			BIO_printf(out,"%d", BN_num_bits(pkey->pkey.rsa->n));
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 794 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_modulus); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_modulus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::modulus", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 396 "OpenSSL.xs"
	char * modulus;
	BIO *out;
	EVP_PKEY *pkey;
	int n;
#line 819 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 401 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_get_pubkey(cert);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->n);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &modulus);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, modulus, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 847 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_exponent); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_exponent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::exponent", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 425 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	char *exponent;
	int n;
#line 872 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 430 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_get_pubkey(cert);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->e);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &exponent);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, exponent, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 900 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_extensions); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_extensions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::extensions", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 454 "OpenSSL.xs"
	BIO *out;
	char *ext;
	X509_CINF *ci;
	int n;
#line 925 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 459 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ci = cert->cert_info;
	// there is a bug in X509V3_extensions_print
	// the causes the function to fail if title == NULL and indent == 0
	X509V3_extensions_print(out, NULL, ci->extensions, 0, 4);
	n = BIO_get_mem_data(out, &ext);
	SAFEFREE(char_ptr);
	if (n)
	{
	        Newz(0, char_ptr, n+1, char);
		memcpy (char_ptr, ext, n);
	}
	RETVAL = char_ptr;
	BIO_free(out);
#line 950 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_signature_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_signature_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::signature_algorithm", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 480 "OpenSSL.xs"
	BIO *out;
	char *sig;
	X509_CINF *ci;
	int n;
#line 975 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 485 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ci = cert->cert_info;
	i2a_ASN1_OBJECT(out, ci->signature->algorithm);
	n = BIO_get_mem_data(out, &sig);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, sig, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 995 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__X509_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__X509_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::X509::signature", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_X509	cert;
#line 501 "OpenSSL.xs"
	BIO *out;
	char *sig;
	int n,i;
	unsigned char *s;
#line 1020 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::X509")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cert = INT2PTR(OpenCA_OpenSSL_X509,tmp);
        }
        else
        	croak("cert is not of type OpenCA::OpenSSL::X509");
#line 506 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	n=cert->signature->length;
	s=cert->signature->data;
	for (i=0; i<n; i++)
	{
		if ( ((i%18) == 0) && (i!=0) ) BIO_printf(out,"\n");
		BIO_printf(out,"%02x%s",s[i], (((i+1)%18) == 0)?"":":");
	}
	n = BIO_get_mem_data(out, &sig);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, sig, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1045 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL__new_from_der); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL__new_from_der)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::_new_from_der", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv = ST(0);
#line 530 "OpenSSL.xs"
	const unsigned char * dercrl;
	SSize_t crllen;
#line 1068 "OpenSSL.c"
	OpenCA_OpenSSL_CRL	RETVAL;
#line 533 "OpenSSL.xs"
	dercrl = SvPV(sv, crllen);
	RETVAL = d2i_X509_CRL(NULL,&dercrl,crllen);
#line 1073 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::CRL",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL__new_from_pem); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL__new_from_pem)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::_new_from_pem", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv = ST(0);
#line 542 "OpenSSL.xs"
	unsigned char * pemcrl;
	const unsigned char * dercrl;
	SSize_t crllen, inlen;
	char inbuf[512];
	BIO *bio_in, *bio_out, *b64;
	X509_CRL *crl;
#line 1102 "OpenSSL.c"
	OpenCA_OpenSSL_CRL	RETVAL;
#line 549 "OpenSSL.xs"
	pemcrl = SvPV(sv, crllen);
	bio_in  = BIO_new(BIO_s_mem());
	bio_out = BIO_new(BIO_s_mem());
	b64     = BIO_new(BIO_f_base64());

	/* load encoded data into bio_in */
	BIO_write(bio_in, pemcrl+25, crllen-25-23);

	/* set EOF for memory bio */
	BIO_set_mem_eof_return(bio_in, 0);

	/* decode data from one bio into another one */
	BIO_push(b64, bio_in);
        while((inlen = BIO_read(b64, inbuf, 512)) > 0)
		BIO_write(bio_out, inbuf, inlen);

	/* create dercert */
	crllen = BIO_get_mem_data(bio_out, &dercrl);

	/* create cert */
	crl = d2i_X509_CRL(NULL,&dercrl,crllen);
	RETVAL = crl;
	BIO_free(bio_in);
	BIO_free(bio_out);
        BIO_free(b64);
#line 1130 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::CRL",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_free); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_free)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::free", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 581 "OpenSSL.xs"
	if (crl != NULL) X509_CRL_free(crl);
        SAFEFREE(char_ptr);
#line 1162 "OpenSSL.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenCA__OpenSSL__CRL_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::version", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 588 "OpenSSL.xs"
	BIO *out;
	char *version;
	unsigned char buf[1024];
	long l;
#line 1186 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 593 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	l = X509_CRL_get_version(crl);
	BIO_printf (out,"%lu (0x%lx)",l+1,l);
	l = BIO_get_mem_data(out, &version);
	SAFEFREE(char_ptr);
	New(0, char_ptr, l+1, char);
	char_ptr[l] = '\0';
	memcpy (char_ptr, version, l);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1207 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_issuer); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_issuer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::issuer", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 610 "OpenSSL.xs"
	BIO *out;
	char *issuer;
	int n;
#line 1231 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 614 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, X509_CRL_get_issuer(crl), 0, OPENCA_FLAG_RFC2253);
	n = BIO_get_mem_data(out, &issuer);
	SAFEFREE(char_ptr);
	New(0, char_ptr, n+1, char);
	char_ptr [n] = '\0';
        memcpy (char_ptr, issuer, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1251 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_issuer_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_issuer_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::issuer_hash", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 630 "OpenSSL.xs"
#line 1272 "OpenSSL.c"
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 631 "OpenSSL.xs"
	RETVAL = X509_NAME_hash(X509_CRL_get_issuer(crl));
#line 1284 "OpenSSL.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_lastUpdate); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_lastUpdate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::lastUpdate", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 639 "OpenSSL.xs"
	char *not;
	int n;
	BIO *out;
#line 1308 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 643 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ASN1_TIME_print(out, X509_CRL_get_lastUpdate(crl));
	n = BIO_get_mem_data(out, &not);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, not, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1327 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_nextUpdate); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_nextUpdate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::nextUpdate", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 658 "OpenSSL.xs"
	char *not;
	int n;
	BIO *out;
#line 1351 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 662 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ASN1_TIME_print(out, X509_CRL_get_nextUpdate(crl));
	n = BIO_get_mem_data(out, &not);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, not, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1370 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_fingerprint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::fingerprint", "crl, digest_name=\"sha1\"");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
	char *	digest_name;
#line 678 "OpenSSL.xs"
	BIO *out;
	int j;
	unsigned int n;
	const EVP_MD *digest;
	char * fingerprint;
	unsigned char md[EVP_MAX_MD_SIZE];
	unsigned char str[3];
#line 1399 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");

	if (items < 2)
	    digest_name = "sha1";
	else {
	    digest_name = (char *)SvPV_nolen(ST(1));
	}
#line 686 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	if (!strcmp ("sha1", digest_name))
		digest = EVP_sha1();
	else
		digest = EVP_md5();
	if (X509_CRL_digest(crl,digest,md,&n))
	{
		BIO_printf(out, "%s:", OBJ_nid2sn(EVP_MD_type(digest)));
		for (j=0; j<(int)n; j++)
		{
			BIO_printf (out, "%02X",md[j]);
			if (j+1 != (int)n) BIO_printf(out,":");
		}
	}
	n = BIO_get_mem_data(out, &fingerprint);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, fingerprint, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1436 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_signature_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_signature_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::signature_algorithm", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 713 "OpenSSL.xs"
	BIO *out;
	char *sig;
	X509_CINF *ci;
	int n;
#line 1461 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 718 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	i2a_ASN1_OBJECT(out, crl->sig_alg->algorithm);
	n = BIO_get_mem_data(out, &sig);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, sig, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1480 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::signature", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 733 "OpenSSL.xs"
	BIO *out;
	char *sig;
	int n,i;
	unsigned char *s;
#line 1505 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 738 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	n=crl->signature->length;
	s=crl->signature->data;
	for (i=0; i<n; i++)
	{
		if ( ((i%18) == 0) && (i!=0) ) BIO_printf(out,"\n");
		BIO_printf(out,"%02x%s",s[i], (((i+1)%18) == 0)?"":":");
	}
	n = BIO_get_mem_data(out, &sig);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, sig, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1530 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_extensions); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_extensions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::extensions", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 759 "OpenSSL.xs"
	BIO *out;
	char *ext;
	int n;
#line 1554 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 763 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	// there is a bug in X509V3_extensions_print
	// the causes the function to fail if title == NULL and indent == 0
	X509V3_extensions_print(out, NULL, crl->crl->extensions, 0, 4);
	n = BIO_get_mem_data(out, &ext);
	SAFEFREE(char_ptr);
	if (n)
	{
		Newz(0, char_ptr, n+1, char);
		memcpy (char_ptr, ext, n);
	}
	RETVAL = char_ptr;
	BIO_free(out);
#line 1578 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_serial); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_serial)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::serial", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 783 "OpenSSL.xs"
	ASN1_INTEGER *aint;
#line 1600 "OpenSSL.c"
	long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 785 "OpenSSL.xs"
	RETVAL = -1;
	aint = X509_CRL_get_ext_d2i (crl, NID_crl_number, NULL, NULL);
	if (aint != NULL)
        {
	    RETVAL = ASN1_INTEGER_get (aint);
            ASN1_INTEGER_free(aint);
        }
#line 1618 "OpenSSL.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__CRL_revoked); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__CRL_revoked)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::CRL::revoked", "crl");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_CRL	crl;
#line 799 "OpenSSL.xs"
	BIO *out;
	char *ext;
	int n,i;
	STACK_OF(X509_REVOKED) *rev;
	X509_REVOKED *r;
#line 1644 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::CRL")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		crl = INT2PTR(OpenCA_OpenSSL_CRL,tmp);
        }
        else
        	croak("crl is not of type OpenCA::OpenSSL::CRL");
#line 805 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	// there is a bug in X509V3_extensions_print
	// the causes the function to fail if title == NULL and indent == 0

	rev = X509_CRL_get_REVOKED(crl);

	for(i = 0; i < sk_X509_REVOKED_num(rev); i++) {
		r = sk_X509_REVOKED_value(rev, i);
		i2a_ASN1_INTEGER(out,r->serialNumber);
		BIO_printf(out,"\n        ");
		ASN1_TIME_print(out,r->revocationDate);
		BIO_printf(out,"\n");
		X509V3_extensions_print(out, NULL,
			r->extensions, 0, 8);
	}
	n = BIO_get_mem_data(out, &ext);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, ext, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1676 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC__new); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC__new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::_new", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv = ST(0);
#line 836 "OpenSSL.xs"
	unsigned char * spkac;
	SSize_t len;
	BIO *bio;
	CONF *conf = NULL;
	int i;
	char *spkstr = NULL;
#line 1703 "OpenSSL.c"
	OpenCA_OpenSSL_SPKAC	RETVAL;
#line 843 "OpenSSL.xs"
	spkac = SvPV(sv, len);

	bio  = BIO_new(BIO_s_mem());

	/* load encoded data into bio */
	BIO_write(bio, spkac, len);

        conf = NCONF_new(NULL);
        i = NCONF_load_bio(conf, bio, NULL);

        if(!i) {
		exit (100);
        }

        spkstr = NCONF_get_string(conf, "default", "SPKAC");

	/* RETVAL = NETSCAPE_SPKI_b64_decode(spkac, len); */
	RETVAL = NETSCAPE_SPKI_b64_decode(spkstr, -1);
	NCONF_free(conf);
	BIO_free(bio);
        /* never free a NCONF part directly !!! */
	/* free(spkstr); */
#line 1728 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::SPKAC",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_pubkey_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_pubkey_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::pubkey_algorithm", "spkac");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 872 "OpenSSL.xs"
	BIO *out;
	char *pubkey;
	X509_CINF *ci;
	int n;
#line 1755 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 877 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	i2a_ASN1_OBJECT(out, spkac->spkac->pubkey->algor->algorithm);
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
	memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1774 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::pubkey", "spkac");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 892 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	char *pubkey;
	int n;
#line 1799 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 897 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_PUBKEY_get(spkac->spkac->pubkey);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			RSA_print(out,pkey->pkey.rsa,0);
		else if (pkey->type == EVP_PKEY_DSA)
			DSA_print(out,pkey->pkey.dsa,0);
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
	memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1826 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_keysize); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_keysize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::keysize", "spkac");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 920 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	char * pubkey;
	int n;
#line 1851 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 925 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_PUBKEY_get(spkac->spkac->pubkey);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			BIO_printf(out,"%d", BN_num_bits(pkey->pkey.rsa->n));
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1876 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_modulus); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_modulus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::modulus", "spkac");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 946 "OpenSSL.xs"
	char * modulus;
	BIO *out;
	EVP_PKEY *pkey;
	int n;
#line 1901 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 951 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_PUBKEY_get(spkac->spkac->pubkey);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->n);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &modulus);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, modulus, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1929 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_exponent); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_exponent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::exponent", "spkac");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_SPKAC	spkac;
#line 975 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	char *exponent;
	int n;
#line 1954 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 980 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_PUBKEY_get(spkac->spkac->pubkey);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->e);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &exponent);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, exponent, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 1982 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_signature_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_signature_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::signature_algorithm", "spkac");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_SPKAC	spkac;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1004 "OpenSSL.xs"
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, 1, char);
	RETVAL = char_ptr;
#line 2015 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::signature", "spkac");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_SPKAC	spkac;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1014 "OpenSSL.xs"
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, 1, char);
	RETVAL = char_ptr;
#line 2048 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__SPKAC_free); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__SPKAC_free)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::SPKAC::free", "spkac");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_SPKAC	spkac;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::SPKAC")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		spkac = INT2PTR(OpenCA_OpenSSL_SPKAC,tmp);
        }
        else
        	croak("spkac is not of type OpenCA::OpenSSL::SPKAC");
#line 1024 "OpenSSL.xs"
	/* 
        if (spkac != NULL) NETSCAPE_SPKI_free(spkac);
	SAFEFREE(char_ptr);
        */
#line 2080 "OpenSSL.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenCA__OpenSSL__PKCS10__new_from_der); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10__new_from_der)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::_new_from_der", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv = ST(0);
#line 1036 "OpenSSL.xs"
	const unsigned char * dercsr;
	SSize_t csrlen;
#line 2102 "OpenSSL.c"
	OpenCA_OpenSSL_PKCS10	RETVAL;
#line 1039 "OpenSSL.xs"
	dercsr = SvPV(sv, csrlen);
	RETVAL = d2i_X509_REQ(NULL,&dercsr,csrlen);
#line 2107 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::PKCS10",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10__new_from_pem); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10__new_from_pem)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::_new_from_pem", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv = ST(0);
#line 1048 "OpenSSL.xs"
	unsigned char * pemcsr;
	const unsigned char * dercsr;
	SSize_t csrlen, inlen;
	char inbuf[512];
	BIO *bio_in, *bio_out, *b64;
#line 2135 "OpenSSL.c"
	OpenCA_OpenSSL_PKCS10	RETVAL;
#line 1054 "OpenSSL.xs"
	pemcsr  = SvPV(sv, csrlen);
	bio_in  = BIO_new(BIO_s_mem());
	bio_out = BIO_new(BIO_s_mem());
	b64     = BIO_new(BIO_f_base64());

	/* load encoded data into bio_in */
	BIO_write(bio_in, pemcsr+36, csrlen-36-34);

	/* set EOF for memory bio */
	BIO_set_mem_eof_return(bio_in, 0);

	/* decode data from one bio into another one */
	BIO_push(b64, bio_in);
        while((inlen = BIO_read(b64, inbuf, 512)) > 0)
		BIO_write(bio_out, inbuf, inlen);

	/* create dercsr */
	csrlen = BIO_get_mem_data(bio_out, &dercsr);

	/* create csr */
	RETVAL = d2i_X509_REQ(NULL,&dercsr,csrlen);
	BIO_free(bio_in);
	BIO_free(bio_out);
	BIO_free(b64);
#line 2162 "OpenSSL.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "OpenCA::OpenSSL::PKCS10",
	(void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::version", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1085 "OpenSSL.xs"
	BIO *out;
	char *version;
	unsigned char buf[1024];
	long l, i;
	const char *neg;
#line 2190 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1091 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());

	neg=(csr->req_info->version->type == V_ASN1_NEG_INTEGER)?"-":"";
	l=0;
	for (i=0; i<csr->req_info->version->length; i++)
		{ l<<=8; l+=csr->req_info->version->data[i]; }
	/* why we use l and not l+1 like for all other versions? */
	BIO_printf(out,"%s%lu (%s0x%lx)",neg,l,neg,l);
	l = BIO_get_mem_data(out, &version);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, l+1, char);
	memcpy (char_ptr, version, l);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2215 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_free); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_free)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::free", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1112 "OpenSSL.xs"
	if (csr != NULL) X509_REQ_free(csr);
	SAFEFREE(char_ptr);
#line 2245 "OpenSSL.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenCA__OpenSSL__PKCS10_subject); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_subject)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::subject", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1119 "OpenSSL.xs"
	BIO *out;
	char *subject;
	int n;
#line 2268 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1123 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	X509_NAME_print_ex(out, csr->req_info->subject, 0, OPENCA_FLAG_RFC2253);
	n = BIO_get_mem_data(out, &subject);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, subject, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2287 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_subject_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_subject_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::subject_hash", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1138 "OpenSSL.xs"
#line 2308 "OpenSSL.c"
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1139 "OpenSSL.xs"
	RETVAL = X509_NAME_hash(csr->req_info->subject);
#line 2320 "OpenSSL.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_fingerprint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::fingerprint", "csr, digest_name=\"sha1\"");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
	char *	digest_name;
#line 1148 "OpenSSL.xs"
	BIO *out;
	int j;
	unsigned int n;
	const EVP_MD *digest;
	char * fingerprint;
	unsigned char md[EVP_MAX_MD_SIZE];
	unsigned char str[3];
#line 2349 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");

	if (items < 2)
	    digest_name = "sha1";
	else {
	    digest_name = (char *)SvPV_nolen(ST(1));
	}
#line 1156 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	if (!strcmp ("sha1", digest_name))
		digest = EVP_sha1();
	else
		digest = EVP_md5();
	if (X509_REQ_digest(csr,digest,md,&n))
	{
		BIO_printf(out, "%s:", OBJ_nid2sn(EVP_MD_type(digest)));
		for (j=0; j<(int)n; j++)
		{
			BIO_printf (out, "%02X",md[j]);
			if (j+1 != (int)n) BIO_printf(out,":");
		}
	}
	n = BIO_get_mem_data(out, &fingerprint);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, fingerprint, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2386 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_emailaddress); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_emailaddress)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::emailaddress", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1183 "OpenSSL.xs"
	int j, n;
        STACK *emlst;
	BIO *out;
	char *emails;
#line 2411 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1188 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	emlst = X509_REQ_get1_email(csr);
	for (j = 0; j < sk_num(emlst); j++)
	{
		BIO_printf(out, "%s", sk_value(emlst, j));
		if (j+1 != (int)sk_num(emlst))
			BIO_printf(out,"\n");
	}
	X509_email_free(emlst);
	n = BIO_get_mem_data(out, &emails);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, emails, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2437 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_pubkey_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_pubkey_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::pubkey_algorithm", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1210 "OpenSSL.xs"
	BIO *out;
	char *pubkey;
	X509_REQ_INFO *ri;
	int n;
#line 2462 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1215 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	ri = csr->req_info;
	i2a_ASN1_OBJECT(out, ri->pubkey->algor->algorithm);
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
	memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2482 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::pubkey", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1231 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	char *pubkey;
	int n;
#line 2507 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1236 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_REQ_get_pubkey(csr);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			RSA_print(out,pkey->pkey.rsa,0);
		else if (pkey->type == EVP_PKEY_DSA)
			DSA_print(out,pkey->pkey.dsa,0);
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
	memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2534 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_keysize); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_keysize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::keysize", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1259 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	unsigned char * pubkey;
	int n;
#line 2559 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1264 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_REQ_get_pubkey(csr);
	if (pkey != NULL)
	{
		if (pkey->type == EVP_PKEY_RSA)
			BIO_printf(out,"%d", BN_num_bits(pkey->pkey.rsa->n));
		EVP_PKEY_free(pkey);
	}
	n = BIO_get_mem_data(out, &pubkey);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, pubkey, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2584 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_modulus); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_modulus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::modulus", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1285 "OpenSSL.xs"
	char * modulus;
	BIO *out;
	EVP_PKEY *pkey;
	int n;
#line 2609 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1290 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_REQ_get_pubkey(csr);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->n);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &modulus);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, modulus, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2637 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_exponent); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_exponent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::exponent", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1314 "OpenSSL.xs"
	BIO *out;
	EVP_PKEY *pkey;
	char *exponent;
	int n;
#line 2662 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1319 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	pkey=X509_REQ_get_pubkey(csr);
	if (pkey == NULL)
		BIO_printf(out,"");
	else if (pkey->type == EVP_PKEY_RSA)
		BN_print(out,pkey->pkey.rsa->e);
	else if (pkey->type == EVP_PKEY_DSA)
		BN_print(out,pkey->pkey.dsa->pub_key);
	else
		BIO_printf(out,"");
	EVP_PKEY_free(pkey);
	n = BIO_get_mem_data(out, &exponent);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, exponent, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2690 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_extensions); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_extensions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::extensions", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1343 "OpenSSL.xs"
	BIO *out;
	char *ext;
	int n;
#line 2714 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1347 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	// there is a bug in X509V3_extensions_print
	// the causes the function to fail if title == NULL and indent == 0
	X509V3_extensions_print(out, NULL, X509_REQ_get_extensions(csr), 0, 4);
	n = BIO_get_mem_data(out, &ext);
	SAFEFREE(char_ptr);
	if (n)
	{
		Newz(0, char_ptr, n+1, char);
		memcpy (char_ptr, ext, n);
	}
	RETVAL = char_ptr;
	BIO_free(out);
#line 2738 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_attributes); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_attributes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::attributes", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1367 "OpenSSL.xs"
	BIO *out;
	char *ext;
	STACK_OF(X509_ATTRIBUTE) *sk;
	int n,i;
#line 2763 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1372 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	sk=csr->req_info->attributes;
	for (i=0; i<sk_X509_ATTRIBUTE_num(sk); i++)
	{
		ASN1_TYPE *at;
		X509_ATTRIBUTE *a;
		ASN1_BIT_STRING *bs=NULL;
		ASN1_TYPE *t;
		int j,type=0,count=1,ii=0;

		a=sk_X509_ATTRIBUTE_value(sk,i);
		if(X509_REQ_extension_nid(OBJ_obj2nid(a->object)))
			continue;
		if ((j=i2a_ASN1_OBJECT(out,a->object)) > 0)
		{
			if (a->single)
			{
				t=a->value.single;
				type=t->type;
				bs=t->value.bit_string;
			}
			else
			{
				ii=0;
				count=sk_ASN1_TYPE_num(a->value.set);
get_next:
				at=sk_ASN1_TYPE_value(a->value.set,ii);
				type=at->type;
				bs=at->value.asn1_string;
			}
		}
		for (j=25-j; j>0; j--)
			BIO_write(out," ",1);
		BIO_puts(out,":");
		if (    (type == V_ASN1_PRINTABLESTRING) ||
			(type == V_ASN1_T61STRING) ||
			(type == V_ASN1_IA5STRING))
		{
			BIO_write(out,(char *)bs->data,bs->length);
			BIO_puts(out,"\n");
		}
		else
			BIO_puts(out,"unable to print attribute\n");
		if (++ii < count) goto get_next;
	}
	n = BIO_get_mem_data(out, &ext);
	SAFEFREE(char_ptr);
	if (n)
	{
		Newz(0, char_ptr, n+1, char);
		memcpy (char_ptr, ext, n);
	}
	RETVAL = char_ptr;
	BIO_free(out);
#line 2828 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_signature_algorithm); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_signature_algorithm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::signature_algorithm", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1433 "OpenSSL.xs"
	BIO *out;
	char *sig;
	int n;
#line 2852 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1437 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	i2a_ASN1_OBJECT(out, csr->sig_alg->algorithm);
	n = BIO_get_mem_data(out, &sig);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, sig, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2871 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_OpenCA__OpenSSL__PKCS10_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenCA__OpenSSL__PKCS10_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenCA::OpenSSL::PKCS10::signature", "csr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	OpenCA_OpenSSL_PKCS10	csr;
#line 1452 "OpenSSL.xs"
	BIO *out;
	char *sig;
	int n,i;
	unsigned char *s;
#line 2896 "OpenSSL.c"
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "OpenCA::OpenSSL::PKCS10")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		csr = INT2PTR(OpenCA_OpenSSL_PKCS10,tmp);
        }
        else
        	croak("csr is not of type OpenCA::OpenSSL::PKCS10");
#line 1457 "OpenSSL.xs"
	out = BIO_new(BIO_s_mem());
	n=csr->signature->length;
	s=csr->signature->data;
	for (i=0; i<n; i++)
	{
		if ( ((i%18) == 0) && (i!=0) ) BIO_printf(out,"\n");
		BIO_printf(out,"%02x%s",s[i], (((i+1)%18) == 0)?"":":");
	}
	n = BIO_get_mem_data(out, &sig);
	SAFEFREE(char_ptr);
	Newz(0, char_ptr, n+1, char);
        memcpy (char_ptr, sig, n);
	RETVAL = char_ptr;
	BIO_free(out);
#line 2921 "OpenSSL.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_OpenCA__OpenSSL); /* prototype to pass -Wmissing-prototypes */
XS(boot_OpenCA__OpenSSL)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("OpenCA::OpenSSL::X509::_new_from_der", XS_OpenCA__OpenSSL__X509__new_from_der, file);
        newXS("OpenCA::OpenSSL::X509::_new_from_pem", XS_OpenCA__OpenSSL__X509__new_from_pem, file);
        newXS("OpenCA::OpenSSL::X509::free", XS_OpenCA__OpenSSL__X509_free, file);
        newXS("OpenCA::OpenSSL::X509::serial", XS_OpenCA__OpenSSL__X509_serial, file);
        newXS("OpenCA::OpenSSL::X509::subject", XS_OpenCA__OpenSSL__X509_subject, file);
        newXS("OpenCA::OpenSSL::X509::openssl_subject", XS_OpenCA__OpenSSL__X509_openssl_subject, file);
        newXS("OpenCA::OpenSSL::X509::issuer", XS_OpenCA__OpenSSL__X509_issuer, file);
        newXS("OpenCA::OpenSSL::X509::notBefore", XS_OpenCA__OpenSSL__X509_notBefore, file);
        newXS("OpenCA::OpenSSL::X509::notAfter", XS_OpenCA__OpenSSL__X509_notAfter, file);
        newXS("OpenCA::OpenSSL::X509::alias", XS_OpenCA__OpenSSL__X509_alias, file);
        newXS("OpenCA::OpenSSL::X509::fingerprint", XS_OpenCA__OpenSSL__X509_fingerprint, file);
        newXS("OpenCA::OpenSSL::X509::subject_hash", XS_OpenCA__OpenSSL__X509_subject_hash, file);
        newXS("OpenCA::OpenSSL::X509::emailaddress", XS_OpenCA__OpenSSL__X509_emailaddress, file);
        newXS("OpenCA::OpenSSL::X509::version", XS_OpenCA__OpenSSL__X509_version, file);
        newXS("OpenCA::OpenSSL::X509::pubkey_algorithm", XS_OpenCA__OpenSSL__X509_pubkey_algorithm, file);
        newXS("OpenCA::OpenSSL::X509::pubkey", XS_OpenCA__OpenSSL__X509_pubkey, file);
        newXS("OpenCA::OpenSSL::X509::keysize", XS_OpenCA__OpenSSL__X509_keysize, file);
        newXS("OpenCA::OpenSSL::X509::modulus", XS_OpenCA__OpenSSL__X509_modulus, file);
        newXS("OpenCA::OpenSSL::X509::exponent", XS_OpenCA__OpenSSL__X509_exponent, file);
        newXS("OpenCA::OpenSSL::X509::extensions", XS_OpenCA__OpenSSL__X509_extensions, file);
        newXS("OpenCA::OpenSSL::X509::signature_algorithm", XS_OpenCA__OpenSSL__X509_signature_algorithm, file);
        newXS("OpenCA::OpenSSL::X509::signature", XS_OpenCA__OpenSSL__X509_signature, file);
        newXS("OpenCA::OpenSSL::CRL::_new_from_der", XS_OpenCA__OpenSSL__CRL__new_from_der, file);
        newXS("OpenCA::OpenSSL::CRL::_new_from_pem", XS_OpenCA__OpenSSL__CRL__new_from_pem, file);
        newXS("OpenCA::OpenSSL::CRL::free", XS_OpenCA__OpenSSL__CRL_free, file);
        newXS("OpenCA::OpenSSL::CRL::version", XS_OpenCA__OpenSSL__CRL_version, file);
        newXS("OpenCA::OpenSSL::CRL::issuer", XS_OpenCA__OpenSSL__CRL_issuer, file);
        newXS("OpenCA::OpenSSL::CRL::issuer_hash", XS_OpenCA__OpenSSL__CRL_issuer_hash, file);
        newXS("OpenCA::OpenSSL::CRL::lastUpdate", XS_OpenCA__OpenSSL__CRL_lastUpdate, file);
        newXS("OpenCA::OpenSSL::CRL::nextUpdate", XS_OpenCA__OpenSSL__CRL_nextUpdate, file);
        newXS("OpenCA::OpenSSL::CRL::fingerprint", XS_OpenCA__OpenSSL__CRL_fingerprint, file);
        newXS("OpenCA::OpenSSL::CRL::signature_algorithm", XS_OpenCA__OpenSSL__CRL_signature_algorithm, file);
        newXS("OpenCA::OpenSSL::CRL::signature", XS_OpenCA__OpenSSL__CRL_signature, file);
        newXS("OpenCA::OpenSSL::CRL::extensions", XS_OpenCA__OpenSSL__CRL_extensions, file);
        newXS("OpenCA::OpenSSL::CRL::serial", XS_OpenCA__OpenSSL__CRL_serial, file);
        newXS("OpenCA::OpenSSL::CRL::revoked", XS_OpenCA__OpenSSL__CRL_revoked, file);
        newXS("OpenCA::OpenSSL::SPKAC::_new", XS_OpenCA__OpenSSL__SPKAC__new, file);
        newXS("OpenCA::OpenSSL::SPKAC::pubkey_algorithm", XS_OpenCA__OpenSSL__SPKAC_pubkey_algorithm, file);
        newXS("OpenCA::OpenSSL::SPKAC::pubkey", XS_OpenCA__OpenSSL__SPKAC_pubkey, file);
        newXS("OpenCA::OpenSSL::SPKAC::keysize", XS_OpenCA__OpenSSL__SPKAC_keysize, file);
        newXS("OpenCA::OpenSSL::SPKAC::modulus", XS_OpenCA__OpenSSL__SPKAC_modulus, file);
        newXS("OpenCA::OpenSSL::SPKAC::exponent", XS_OpenCA__OpenSSL__SPKAC_exponent, file);
        newXS("OpenCA::OpenSSL::SPKAC::signature_algorithm", XS_OpenCA__OpenSSL__SPKAC_signature_algorithm, file);
        newXS("OpenCA::OpenSSL::SPKAC::signature", XS_OpenCA__OpenSSL__SPKAC_signature, file);
        newXS("OpenCA::OpenSSL::SPKAC::free", XS_OpenCA__OpenSSL__SPKAC_free, file);
        newXS("OpenCA::OpenSSL::PKCS10::_new_from_der", XS_OpenCA__OpenSSL__PKCS10__new_from_der, file);
        newXS("OpenCA::OpenSSL::PKCS10::_new_from_pem", XS_OpenCA__OpenSSL__PKCS10__new_from_pem, file);
        newXS("OpenCA::OpenSSL::PKCS10::version", XS_OpenCA__OpenSSL__PKCS10_version, file);
        newXS("OpenCA::OpenSSL::PKCS10::free", XS_OpenCA__OpenSSL__PKCS10_free, file);
        newXS("OpenCA::OpenSSL::PKCS10::subject", XS_OpenCA__OpenSSL__PKCS10_subject, file);
        newXS("OpenCA::OpenSSL::PKCS10::subject_hash", XS_OpenCA__OpenSSL__PKCS10_subject_hash, file);
        newXS("OpenCA::OpenSSL::PKCS10::fingerprint", XS_OpenCA__OpenSSL__PKCS10_fingerprint, file);
        newXS("OpenCA::OpenSSL::PKCS10::emailaddress", XS_OpenCA__OpenSSL__PKCS10_emailaddress, file);
        newXS("OpenCA::OpenSSL::PKCS10::pubkey_algorithm", XS_OpenCA__OpenSSL__PKCS10_pubkey_algorithm, file);
        newXS("OpenCA::OpenSSL::PKCS10::pubkey", XS_OpenCA__OpenSSL__PKCS10_pubkey, file);
        newXS("OpenCA::OpenSSL::PKCS10::keysize", XS_OpenCA__OpenSSL__PKCS10_keysize, file);
        newXS("OpenCA::OpenSSL::PKCS10::modulus", XS_OpenCA__OpenSSL__PKCS10_modulus, file);
        newXS("OpenCA::OpenSSL::PKCS10::exponent", XS_OpenCA__OpenSSL__PKCS10_exponent, file);
        newXS("OpenCA::OpenSSL::PKCS10::extensions", XS_OpenCA__OpenSSL__PKCS10_extensions, file);
        newXS("OpenCA::OpenSSL::PKCS10::attributes", XS_OpenCA__OpenSSL__PKCS10_attributes, file);
        newXS("OpenCA::OpenSSL::PKCS10::signature_algorithm", XS_OpenCA__OpenSSL__PKCS10_signature_algorithm, file);
        newXS("OpenCA::OpenSSL::PKCS10::signature", XS_OpenCA__OpenSSL__PKCS10_signature, file);
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

